"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var got_1 = __importDefault(require("got"));
var domino = __importStar(require("domino"));
__exportStar(require("./types"), exports);
var rules_1 = require("./rules");
var defaultOptions = {
    maxRedirects: 5,
    ua: 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36',
    lang: '*',
    timeout: 10000,
    forceImageHttps: true,
    customRules: {}
};
var runRule = function (ruleSet, doc, context) {
    var maxScore = 0;
    var value;
    for (var currRule = 0; currRule < ruleSet.rules.length; currRule++) {
        var _a = ruleSet.rules[currRule], query = _a[0], handler = _a[1];
        var elements = Array.from(doc.querySelectorAll(query));
        if (elements.length) {
            for (var _i = 0, elements_1 = elements; _i < elements_1.length; _i++) {
                var element = elements_1[_i];
                var score = ruleSet.rules.length - currRule;
                if (ruleSet.scorer) {
                    var newScore = ruleSet.scorer(element, score);
                    if (newScore) {
                        score = newScore;
                    }
                }
                if (score > maxScore) {
                    maxScore = score;
                    value = handler(element);
                }
            }
        }
    }
    if (value) {
        if (ruleSet.processor) {
            value = ruleSet.processor(value, context);
        }
        return value;
    }
    if ((!value || value.length < 1) && ruleSet.defaultValue) {
        return ruleSet.defaultValue(context);
    }
    return undefined;
};
var getMetaData = function (input, inputOptions) {
    if (inputOptions === void 0) { inputOptions = {}; }
    return __awaiter(this, void 0, void 0, function () {
        var url, options, rules, html, response, metadata, context, doc;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (typeof input === 'object') {
                        inputOptions = input;
                        url = input.url || '';
                    }
                    else {
                        url = input;
                    }
                    options = Object.assign({}, defaultOptions, inputOptions);
                    rules = __assign({}, rules_1.metaDataRules);
                    Object.keys(options.customRules).forEach(function (key) {
                        rules[key] = {
                            rules: __spreadArray(__spreadArray([], rules_1.metaDataRules[key].rules, true), options.customRules[key].rules, true),
                            defaultValue: options.customRules[key].defaultValue || rules_1.metaDataRules[key].defaultValue,
                            processor: options.customRules[key].processor || rules_1.metaDataRules[key].processor
                        };
                    });
                    if (!!options.html) return [3 /*break*/, 2];
                    return [4 /*yield*/, (0, got_1.default)(url, __assign({ headers: {
                                'User-Agent': options.ua,
                                'Accept-Language': options.lang
                            }, timeout: options.timeout }, (options.maxRedirects === 0 ? { followRedirect: false } : { maxRedirects: options.maxRedirects })))];
                case 1:
                    response = _a.sent();
                    html = response.body;
                    return [3 /*break*/, 3];
                case 2:
                    html = options.html;
                    _a.label = 3;
                case 3:
                    metadata = {};
                    context = {
                        url: url,
                        options: options
                    };
                    doc = domino.createWindow(html).document;
                    Object.keys(rules).map(function (key) {
                        var ruleSet = rules[key];
                        metadata[key] = runRule(ruleSet, doc, context) || undefined;
                    });
                    return [2 /*return*/, metadata];
            }
        });
    });
};
exports.default = getMetaData;
module.exports = getMetaData;
